%global srcname heat

Summary:        OpenStack Orchestration (%{srcname})
Name:           openstack-%{srcname}
Version:        16.0.0
Release:        2%{?dist}
License:        ASL 2.0
URL:            http://www.openstack.org
Source0:        https://tarballs.openstack.org/%{srcname}/%{name}-%{version}.tar.gz


Source1:        %{srcname}.logrotate
Source2:        openstack-%{srcname}-api.service
Source3:        openstack-%{srcname}-api-cfn.service
Source4:        openstack-%{srcname}-engine.service
Source5:        %{srcname}-dist.conf

Provides:       %{srcname}

BuildArch: noarch

BuildRequires: python3-testscenarios python3-tempest python3-gabbi python3-zunclient
BuildRequires: python3-manilaclient python3-zaqarclient python3-croniter python3-gabbi
BuildRequires: python3-barbicanclient python3-designateclient python3-magnumclient python3-monascaclient
BuildRequires: python3-heatclient python3-glanceclient python3-troveclient python3-aodhclient
BuildRequires: python3-novaclient python3-saharaclient python3-neutronclient python3-swiftclient
BuildRequires: python3-openstackdocstheme python3-sphinx python3-sphinxcontrib-apidoc python3-cinderclient
BuildRequires: python3-paste-deploy python3-redis python3-webob systemd
BuildRequires: python3-babel python3-yaml python3-lxml python3-migrate
BuildRequires: python3-oslo-config python3-keystoneauth1 python3-keystoneclient python3-tenacity
BuildRequires: python3-routes python3-sqlalchemy python3-pbr python3-cryptography
BuildRequires: python3-osprofiler python3-six python3-paramiko python3-yaql
BuildRequires: python3-eventlet python3-kombu python3-netaddr python3-neutron-lib
BuildRequires: python3-oslo-upgradecheck python3-oslo-utils python3-oslo-log python3-oslo-versionedobjects
BuildRequires: python3-oslo-messaging python3-setuptools python3-oslo-i18n python3-oslo-db
BuildRequires: python3-oslo-cache python3-oslo-context python3-oslo-middleware python3-oslo-policy
BuildRequires: git-core python3-devel python3-stevedore python3-docutils

Requires: %{name}-common = %{version}-%{release}
Requires: %{name}-engine = %{version}-%{release}
Requires: %{name}-api = %{version}-%{release}
Requires: %{name}-api-cfn = %{version}-%{release}
Requires: python3-neutron-lib python3-aodhclient


%description
Heat is a service to orchestrate composite cloud applications using a
declarative template format through an OpenStack-native REST API.

%package -n python3-%{srcname}-tests
Summary:        Heat tests
Requires: python3-eventlet python3-gabbi python3-yaml
Requires: python3-swiftclient python3-paramiko python3-kombu python3-oslo-config python3-oslo-concurrency python3-requests
Requires: python3-oslo-log python3-oslo-utils python3-heatclient python3-cinderclient python3-zaqarclient python3-keystoneclient
Requires: %{name}-common = %{version}-%{release} python3-oslotest python3-testresources python3-oslotest
Requires: %{name}-api = %{version}-%{release} %{name}-api-cfn = %{version}-%{release}
Requires: %{name}-common = %{version}-%{release} %{name}-engine = %{version}-%{release}

%description -n python3-%{srcname}-tests
This package contains the Heat test files.

%package common
Summary: Heat common
Group: System Environment/Base
Requires: python3-webob python3-pytz
Requires: python3-openstacksdk python3-tenacity python3-yaml python3-lxml python3-migrate python3-paste-deploy
Requires: python3-openstackclient python3-zaqarclient python3-aodhclient python3-magnumclient python3-octaviaclient python3-ironicclient
Requires: python3-troveclient python3-keystoneauth1 python3-barbicanclient python3-designateclient python3-manilaclient python3-mistralclient
Requires: python3-keystoneclient python3-keystonemiddleware python3-neutronclient python3-novaclient python3-saharaclient python3-swiftclient
Requires: python3-oslo-log python3-oslo-versionedobjects python3-debtcollector python3-cinderclient python3-glanceclient python3-heatclient
Requires: python3-oslo-middleware python3-oslo-messaging python3-oslo-policy python3-oslo-reports python3-oslo-serialization python3-oslo-service
Requires: python3-oslo-config python3-oslo-context python3-oslo-upgradecheck python3-oslo-utils python3-oslo-db python3-oslo-i18n
Requires: python3-paramiko python3-babel python3-cryptography python3-yaql python3-oslo-cache python3-oslo-concurrency
Requires: python3-netaddr python3-neutron-lib python3-osprofiler python3-requests python3-routes python3-sqlalchemy python3-pbr python3-croniter python3-eventlet python3-stevedore

%description common
Components common to all OpenStack Heat services

%package engine
Summary: The Heat engine
Requires: %{name}-common = %{version}-%{release}
%{?systemd_ordering}

%description engine
The %{srcname}-engine's main responsibility is to orchestrate the launching of
templates and provide events back to the API consumer.

%package api
Summary: The Heat API
Requires: %{name}-common = %{version}-%{release}
%{?systemd_ordering} 

%description api
The %{srcname}-api component provides an OpenStack-native REST API that processes API
requests by sending them to the %{srcname}-engine over RPC.

%package api-cfn
Summary: Heat CloudFormation API
Requires: %{name}-common = %{version}-%{release}
%{?systemd_ordering}

%description api-cfn
The %{srcname}-api-cfn component provides an AWS Query API that is compatible with
AWS CloudFormation and processes API requests by sending them to the
%{srcname}-engine over RPC.

%package monolith
Summary: The combined Heat engine/API
Requires: %{name}-common = %{version}-%{release}
%{?systemd_ordering}

%description monolith
The %{srcname}-all process bundles together any (or all) of %{srcname}-engine,
%{srcname}-api, and %{srcname}-cfn-api into a single process. This can be used
to bootstrap a minimal TripleO deployment, but is not the recommended way of
running the Heat service in general.

%prep
%autosetup -n openstack-%{srcname}-%{version} -S git

sed -i "s/from oslo_utils import fnmatch/import fnmatch/g" heat/engine/environment.py
rm -rf *requirements.txt
find contrib -name tests -type d | xargs rm -r

%build
%{py3_build}

%{__python3} setup.py compile_catalog -d build/lib/%{srcname}/locale

PYTHONPATH=. oslo-config-generator --config-file=config-generator.conf

%install
%{py3_install}
sed -i -e '/^#!/,1 d' %{buildroot}/%{python3_sitelib}/%{srcname}/db/sqlalchemy/migrate_repo/manage.py

mkdir -p %{buildroot}/%{_localstatedir}/log/%{srcname}/
mkdir -p %{buildroot}/%{_localstatedir}/run/%{srcname}/
install -p -D -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/logrotate.d/openstack-%{srcname}
install -p -D -m 644 %{SOURCE2} %{buildroot}%{_unitdir}/openstack-%{srcname}-api.service
install -p -D -m 644 %{SOURCE3} %{buildroot}%{_unitdir}/openstack-%{srcname}-api-cfn.service
install -p -D -m 644 %{SOURCE4} %{buildroot}%{_unitdir}/openstack-%{srcname}-engine.service
install -p -D -m 644 %{SOURCE2} %{buildroot}%{_unitdir}/openstack-%{srcname}-all.service

mkdir -p %{buildroot}/%{_sharedstatedir}/%{srcname}/
mkdir -p %{buildroot}/%{_sysconfdir}/%{srcname}/

rm -f %{buildroot}/%{_bindir}/%{srcname}-db-setup
rm -f %{buildroot}/%{_mandir}/man1/%{srcname}-db-setup.*
rm -rf %{buildroot}/var/lib/%{srcname}/.dummy
rm -f %{buildroot}/usr/bin/cinder-keystone-setup

install -D -pm640 etc/%{srcname}/%{srcname}.conf.sample %{buildroot}/%{_sysconfdir}/%{srcname}/%{srcname}.conf
install -D -pm640 %{SOURCE5} %{buildroot}%{_datadir}/%{srcname}/%{srcname}-dist.conf
echo '[revision]' >> %{buildroot}%{_datadir}/%{srcname}/%{srcname}-dist.conf
echo '%{srcname}_revision=%{version}' >> %{buildroot}%{_datadir}/%{srcname}/%{srcname}-dist.conf
mv %{buildroot}%{_prefix}/etc/%{srcname}/api-paste.ini %{buildroot}/%{_datadir}/%{srcname}/api-paste-dist.ini
mv %{buildroot}%{_prefix}/etc/%{srcname}/environment.d %{buildroot}/%{_sysconfdir}/%{srcname}
mv %{buildroot}%{_prefix}/etc/%{srcname}/templates %{buildroot}/%{_sysconfdir}/%{srcname}
rmdir %{buildroot}%{_prefix}/etc/%{srcname}

install -d -m 755 %{buildroot}%{_datadir}
rm -f %{buildroot}%{python3_sitelib}/%{srcname}/locale/*/LC_*/%{srcname}*po
rm -f %{buildroot}%{python3_sitelib}/%{srcname}/locale/*pot
mv %{buildroot}%{python3_sitelib}/%{srcname}/locale %{buildroot}%{_datadir}/locale

%find_lang %{srcname} --all-name

%pre common
getent group %{srcname} >/dev/null || groupadd -r --gid 187 %{srcname}
getent passwd %{srcname}  >/dev/null || \
useradd --uid 187 -r -g %{srcname} -d %{_sharedstatedir}/%{srcname} -s /sbin/nologin \
-c "OpenStack Heat Daemons" %{srcname}
exit 0

%post engine
%systemd_post openstack-%{srcname}-engine.service

%preun engine
%systemd_preun openstack-%{srcname}-engine.service

%postun engine
%systemd_postun_with_restart openstack-%{srcname}-engine.service

%post api
%systemd_post openstack-%{srcname}-api.service

%preun api
%systemd_preun openstack-%{srcname}-api.service

%postun api
%systemd_postun_with_restart openstack-%{srcname}-api.service

%post api-cfn
%systemd_post openstack-%{srcname}-api-cfn.service

%preun api-cfn
%systemd_preun openstack-%{srcname}-api-cfn.service

%postun api-cfn
%systemd_postun_with_restart openstack-%{srcname}-api-cfn.service

%post monolith
%systemd_post openstack-%{srcname}-all.service

%preun monolith
%systemd_preun openstack-%{srcname}-all.service

%postun monolith
%systemd_postun_with_restart openstack-%{srcname}-all.service

%files common -f %{srcname}.lang
%license LICENSE
%{_bindir}/%{srcname}-manage
%{_bindir}/%{srcname}-status
%{_bindir}/%{srcname}-keystone-setup
%{_bindir}/%{srcname}-keystone-setup-domain
%{python3_sitelib}/%{srcname}
%{python3_sitelib}/openstack_%{srcname}-%{version}-*.egg-info
%exclude %{python3_sitelib}/%{srcname}/tests
%attr(-, root, %{srcname}) %{_datadir}/%{srcname}/%{srcname}-dist.conf
%attr(-, root, %{srcname}) %{_datadir}/%{srcname}/api-paste-dist.ini
%dir %attr(0755,%{srcname},root) %{_localstatedir}/log/%{srcname}
%dir %attr(0755,%{srcname},root) %{_localstatedir}/run/%{srcname}
%dir %attr(0755,%{srcname},root) %{_sharedstatedir}/%{srcname}
%dir %attr(0755,%{srcname},root) %{_sysconfdir}/%{srcname}
%config(noreplace) %{_sysconfdir}/logrotate.d/openstack-%{srcname}
%config(noreplace) %attr(-, root, %{srcname}) %{_sysconfdir}/%{srcname}/%{srcname}.conf
%config(noreplace) %attr(-,root,%{srcname}) %{_sysconfdir}/%{srcname}/environment.d/*
%config(noreplace) %attr(-,root,%{srcname}) %{_sysconfdir}/%{srcname}/templates/*

%files -n python3-%{srcname}-tests
%license LICENSE
%{python3_sitelib}/%{srcname}/tests
%{python3_sitelib}/%{srcname}_integrationtests

%files engine
%license LICENSE
%doc README.rst
%{_bindir}/%{srcname}-engine
%{_unitdir}/openstack-%{srcname}-engine.service

%files api
%license LICENSE
%doc README.rst
%{_bindir}/%{srcname}-api
%{_bindir}/%{srcname}-wsgi-api
%{_unitdir}/openstack-%{srcname}-api.service

%files api-cfn
%license LICENSE
%doc README.rst
%{_bindir}/%{srcname}-api-cfn
%{_bindir}/%{srcname}-wsgi-api-cfn
%{_unitdir}/openstack-%{srcname}-api-cfn.service

%files monolith
%license LICENSE
%doc README.rst
%{_bindir}/%{srcname}-all
%{_unitdir}/openstack-%{srcname}-all.service


%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 16.0.0-2
- Rebuilt for OpenCloudOS Stream 23.05

* Wed Apr 19 2023 cunshunxia <cunshunxia@tencent.com> - 16.0.0-1
- initial build
